/*
 * util.h -- common utility routines for thrulay, headers.
 * 
 * Written by Stanislav Shalunov, http://www.internet2.edu/~shalunov/
 * 
 * @(#) $Id: util.h,v 1.8 2005/01/12 02:38:16 shalunov Exp $
 * 
 * Copyright 2003, Internet2.
 * Legal conditions are in file LICENSE
 * (MD5 = ecfa50d1b0bfbb81b658c810d0476a52).
 */

#ifndef THRULAY_UTIL_H_INCLUDED
#define THRULAY_UTIL_H_INCLUDED

#include <sys/types.h>
#include <sys/uio.h>
#include <sys/time.h>
#include <unistd.h>

#define BLOCK_HEADER 16
#define MIN_BLOCK BLOCK_HEADER
#define MAX_BLOCK 1048576

#define ERR_FATAL	0
#define ERR_WARNING	1

void
error(int, const char *);

ssize_t
read_exactly(int, void *, size_t);

ssize_t
write_exactly(int, const void *, size_t);

double
time_diff(const struct timeval *, const struct timeval *);

int
set_window_size_directed(int, int, int);

int
set_window_size(int, int);

#endif /* ifndef THRULAY_UTIL_H_INCLUDED */
